'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Prefetcher = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _md = require('md5');

var _md2 = _interopRequireDefault(_md);

var _lodash = require('./lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _rxjs = require('./rxjs');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ARGS_REGEX = /\(.*\)/g;
var CLEAN_REGEX = /\t+|\s{2,}/g;

var Prefetcher = exports.Prefetcher = function () {
    function Prefetcher(graphql) {
        var components = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        _classCallCheck(this, Prefetcher);

        if (!graphql) {
            throw new Error('No graphql runner provided.');
        }

        this.graphql = graphql;
        this.components = components;
    }

    _createClass(Prefetcher, [{
        key: 'run',
        value: function run(descriptor) {
            var _this = this;

            if (!descriptor) {
                return _rxjs.Observable.throw(new Error('No descriptor provided.'));
            }

            return this.resolveDescriptor(descriptor).mergeMap(function (resolution) {
                if (!resolution) {
                    return _rxjs.Observable.throw(new Error('Inexistent ROOT component.'));
                }

                return _this.runQueries(resolution).map(function (queries) {
                    return _this.decorateComponent(resolution, queries);
                });
            });
        }
    }, {
        key: 'query',
        value: function query(params) {
            var query = params.query,
                _params$args = params.args,
                args = _params$args === undefined ? {} : _params$args,
                _params$callback = params.callback,
                callback = _params$callback === undefined ? null : _params$callback;

            var _resolveQuery = this.resolveQuery(query, args),
                parsedQuery = _resolveQuery.parsedQuery;

            return this.runGraph(parsedQuery).do(function (response) {
                if (callback) {
                    callback(response);
                }
            });
        }
    }, {
        key: 'resolveDescriptor',
        value: function resolveDescriptor(descriptor) {
            var _this2 = this;

            return _rxjs.Observable.of(descriptor).mergeMap(function (descriptor) {
                var component = descriptor.component,
                    _descriptor$args = descriptor.args,
                    args = _descriptor$args === undefined ? {} : _descriptor$args,
                    _descriptor$props = descriptor.props,
                    props = _descriptor$props === undefined ? {} : _descriptor$props;


                if (_lodash2.default.isString(component) && !_lodash2.default.isEmpty(_this2.components)) {
                    component = _lodash2.default.get(_this2.components, component, null);
                }

                if (!_lodash2.default.isObject(component)) {
                    return _rxjs.Observable.of(null);
                }

                var _component = component,
                    _component$queries = _component.queries,
                    queries = _component$queries === undefined ? null : _component$queries,
                    _component$dependenci = _component.dependencies,
                    dependencies = _component$dependenci === undefined ? null : _component$dependenci;


                var _resolveDependencies = _this2.resolveDependencies(dependencies, props);
                var _resolveQueries = _this2.resolveQueries(queries, args, props);

                return _rxjs.Observable.forkJoin(_resolveDependencies, _resolveQueries).map(function (_ref) {
                    var _ref2 = _slicedToArray(_ref, 2),
                        dependencies = _ref2[0],
                        _queries = _ref2[1];

                    var _ref3 = _queries || {},
                        queries = _ref3.queries,
                        queriesMap = _ref3.queriesMap;

                    return {
                        component: component,
                        props: props,
                        queries: queries,
                        queriesMap: queriesMap,
                        dependencies: dependencies
                    };
                });
            });
        }
    }, {
        key: 'resolveDependencies',
        value: function resolveDependencies(dependencies) {
            var _this3 = this;

            var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            dependencies = _lodash2.default.isFunction(dependencies) ? dependencies(props) : dependencies || null;

            if (!(dependencies instanceof _rxjs.Observable)) {
                dependencies = _rxjs.Observable.of(dependencies);
            }

            var resolve = function resolve(descriptor) {
                return _this3.resolveDescriptor(descriptor);
            };

            return dependencies.filter(_lodash2.default.size).mergeMap(function (dependencies) {
                var dependenciesKeys = _lodash2.default.keys(dependencies);
                var dependenciesToResolve = _lodash2.default.map(dependencies, function (descriptor) {
                    if (_lodash2.default.isArray(descriptor)) {
                        return _rxjs.Observable.forkJoin(_lodash2.default.map(descriptor, resolve));
                    }

                    return resolve(descriptor);
                });

                return _rxjs.Observable.forkJoin(dependenciesToResolve, function () {
                    for (var _len = arguments.length, resolvedDependencies = Array(_len), _key = 0; _key < _len; _key++) {
                        resolvedDependencies[_key] = arguments[_key];
                    }

                    return _lodash2.default.zipObject(dependenciesKeys, resolvedDependencies);
                }).filter(_lodash2.default.size);
            }).defaultIfEmpty(null);
        }
    }, {
        key: 'resolveQueries',
        value: function resolveQueries(queries) {
            var _this4 = this;

            var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
            var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

            queries = _lodash2.default.isFunction(queries) ? queries(props) : queries || null;

            if (!(queries instanceof _rxjs.Observable)) {
                queries = _rxjs.Observable.of(queries);
            }

            return queries.filter(_lodash2.default.size).mergeMap(_rxjs.Observable.pairs.bind(_rxjs.Observable)).mergeMap(function (_ref4) {
                var _ref5 = _slicedToArray(_ref4, 2),
                    key = _ref5[0],
                    value = _ref5[1];

                if (_lodash2.default.isFunction(value)) {
                    value = value(_lodash2.default.get(args, key, null));
                }

                if (!(value instanceof _rxjs.Observable)) {
                    value = _rxjs.Observable.of(value);
                }

                return value.map(function (response) {
                    var query = response.query,
                        _response$args = response.args,
                        args = _response$args === undefined ? {} : _response$args,
                        _response$callback = response.callback,
                        callback = _response$callback === undefined ? null : _response$callback;


                    return {
                        key: key,
                        query: query,
                        args: args,
                        callback: callback
                    };
                });
            }).reduce(function (reduction, _ref6) {
                var key = _ref6.key,
                    query = _ref6.query,
                    args = _ref6.args,
                    callback = _ref6.callback;

                if (_lodash2.default.isNull(reduction)) {
                    reduction = {
                        queries: [],
                        queriesMap: {}
                    };
                }

                var _resolveQuery2 = _this4.resolveQuery(query, args),
                    hash = _resolveQuery2.hash,
                    parsedQuery = _resolveQuery2.parsedQuery;

                reduction.queries = _lodash2.default.uniq([].concat(_toConsumableArray(reduction.queries), [hash + ':' + parsedQuery]));

                reduction.queriesMap[key] = {
                    hash: hash,
                    callback: callback
                };

                return reduction;
            }, null);
        }
    }, {
        key: 'resolveQuery',
        value: function resolveQuery(query) {
            var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            var queryArgs = query.match(ARGS_REGEX);

            if (!_lodash2.default.isEmpty(queryArgs)) {
                query = _lodash2.default.reduce(queryArgs, function (reduction, queryArg) {
                    var splittedArgs = _lodash2.default.map(_lodash2.default.trim(queryArg, '()').split(','), function (arg) {
                        var _arg$split = arg.split(':'),
                            _arg$split2 = _slicedToArray(_arg$split, 1),
                            key = _arg$split2[0];

                        return {
                            key: key.trim()
                        };
                    });

                    var resolvedArgs = _lodash2.default.reduce(splittedArgs, function (reduction, _ref7) {
                        var key = _ref7.key;

                        var value = _lodash2.default.get(args, key);

                        if (!_lodash2.default.isUndefined(value)) {
                            value = _lodash2.default.isString(value) ? '"' + value + '"' : value;

                            reduction.push(key + ': ' + value);
                        }

                        return reduction;
                    }, []);

                    return reduction.replace(queryArg, _lodash2.default.size(resolvedArgs) ? '(' + resolvedArgs.join(', ') + ')' : '');
                }, query);
            }

            var parsedQuery = query.replace(CLEAN_REGEX, ' ');

            return {
                parsedQuery: parsedQuery,
                hash: 'q' + (0, _md2.default)(parsedQuery)
            };
        }
    }, {
        key: 'flattenQueries',
        value: function flattenQueries(resolution) {
            return _rxjs.Observable.of(resolution).expand(function (resolution) {
                if (resolution && resolution.dependencies) {
                    return _rxjs.Observable.pairs(resolution.dependencies).mergeMap(function (dependency) {
                        var _dependency = _slicedToArray(dependency, 2),
                            resolution = _dependency[1];

                        if (_lodash2.default.isArray(resolution)) {
                            return _rxjs.Observable.from(resolution);
                        }

                        return _rxjs.Observable.of(resolution);
                    });
                }

                return _rxjs.Observable.empty();
            }).reduce(function (reduction, resolution) {
                if (resolution && resolution.queries) {
                    reduction = _lodash2.default.uniq([].concat(_toConsumableArray(reduction), _toConsumableArray(resolution.queries)));
                }

                return reduction;
            }, []).filter(_lodash2.default.size).defaultIfEmpty(null);
        }
    }, {
        key: 'runQueries',
        value: function runQueries(resolution) {
            return this.flattenQueries(resolution).filter(_lodash2.default.size).map(function (queries) {
                return queries.join();
            }).mergeMap(this.runGraph.bind(this)).defaultIfEmpty(null);
        }
    }, {
        key: 'runGraph',
        value: function runGraph(query) {
            return this.graphql({
                query: '{' + query + '}'
            }).map(function (response) {
                return response.data || response;
            });
        }
    }, {
        key: 'decorateComponent',
        value: function decorateComponent(resolution) {
            var _this5 = this;

            var queries = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            if (!resolution) {
                return null;
            }

            var component = resolution.component,
                props = resolution.props,
                queriesMap = resolution.queriesMap,
                dependencies = resolution.dependencies;
            var _component2 = component,
                info = _component2.info;


            var resolvedQueries = _lodash2.default.mapValues(queriesMap, function (_ref8) {
                var hash = _ref8.hash,
                    callback = _ref8.callback;

                var value = _lodash2.default.get(queries, hash, null);

                if (value && _lodash2.default.isFunction(callback)) {
                    callback(value);
                }

                return value;
            });

            var resolvedDependencies = _lodash2.default.mapValues(dependencies, function (dependencyResolution) {
                var resolve = function resolve(resolution) {
                    return _this5.decorateComponent(resolution, queries);
                };

                if (_lodash2.default.isArray(dependencyResolution)) {
                    return _lodash2.default.map(dependencyResolution, resolve);
                }

                return resolve(dependencyResolution);
            });

            if (!_lodash2.default.isEmpty(props) || !_lodash2.default.isEmpty(resolvedQueries) || !_lodash2.default.isEmpty(resolvedDependencies)) {
                component = (0, _utils.decorateWithProps)(component, _extends({}, props, {
                    queries: resolvedQueries,
                    dependencies: resolvedDependencies
                }));
            }

            if (info) {
                return {
                    component: component,
                    info: _lodash2.default.isFunction(info) ? info(props, resolvedQueries) : info || null
                };
            }

            return component;
        }
    }]);

    return Prefetcher;
}();